#[inline]
pub fn bytes(bytes: &[u8]) -> usize {
    let mut hash: usize = 0;
    let (chunks, remainder) = bytes.as_chunks::<8>();
    for &chunk in chunks {
        hash = hash.wrapping_add(usize::from_be_bytes(chunk));
    }
    let mut r = [0_u8; 8];
    r[0] = remainder.len() as u8;
    let mut idx = 1;
    for &byte in remainder {
        r[idx] = byte;
        idx += 1;
    }
    hash += usize::from_be_bytes(r);
    hash
}

#[cfg(test)]
mod tests {
    use crate::utils::hash;

    #[test]
    fn test_hashstr() {
        let hash_1 = hash::bytes(b"abcdefghijk");
        let hash_2 = hash::bytes(b"kjihgfedcba");
        let hash_3 = hash::bytes(b"abba");
        let hash_4 = hash::bytes(b"baab");

        assert_ne!(hash_1, hash_2);
        assert_ne!(hash_3, hash_4);
    }
}