use std::fs::File;
use std::io::{BufRead, BufReader, BufWriter, Write};

pub fn write_structured_measurements() {
    let file = File::open("../../../measurements.txt").expect("File measurements.txt not found");
    let structured_file =
        File::create_new("structured_measurements.txt").expect("Could not create file");
    let mut reader = BufReader::new(&file);
    let mut writer = BufWriter::new(&structured_file);
    let mut line = Vec::with_capacity(107);
    let mut line_num = 0;
    loop {
        line_num += 1;
        let line_len = reader
            .read_until(b'\n', &mut line)
            .expect("could not read bytes");
        if line_len == 0 {
            break;
        }
        if line_num % 100000 == 0 {
            print!("\x1b[0Glines: {line_num}");
        }
        let (station, temp) = line.rsplit_once(|&byte| byte == b';').unwrap();
        let station_len = station.len();
        let temp_val_start = 107 - temp.len();
        let mut write_line = [0u8; 107];
        write_line[..station_len].clone_from_slice(station);
        write_line[100] = b';';
        write_line[temp_val_start..temp_val_start + temp.len()].clone_from_slice(temp);
        write_line[106] = b'\n';
        writer
            .write_all(write_line.as_slice())
            .expect("Could not write");
        line.clear();
    }
}
